#!/usr/bin/env python
# -*- coding: utf-8 -*-

#pyuic4 -x name.ui -o name.py
from PyQt4 import QtGui, QtCore
from Test7dec import Ui_Inductor_Calculator
from Wbs03InductorCoreOptimizer import convertStr
from Wbs03InductorCoreOptimizer import MainSheel_initalize

import sys

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s
   

class TestWindow(QtGui.QWidget,Ui_Inductor_Calculator):
    def __init__( self, parent=None):
        super(TestWindow, self).__init__(parent)
        self.setupUi(self)
        self.connect(self.pushButton_2, QtCore.SIGNAL("clicked()"),self.Run)       

    def Run(self):
         
         
         Height_Limited  = 500000.0 #just intilized height limit 500 m
         Diameter_Limited= 500000.0 #just intilized diameter limit 500 m
         AirGapLimit     = 500000.0 #just intilized airgap limit 500 m
         Heatsink        = 500000.0 #Resistance lets say this is infinity
         BoundleD        = 0.0
         StradD          = 0.0
         Thermalwinding  = 0.0      #Resistance only optional so 0 will be changed to something appropiate later          
         P_Forced_Conv   = 0.0# m/s
         CoreNumber      = 0.0
         LitzWire        = [0,0,0,0]
         
         Idc             = convertStr(self.P_Bias.text()) 
         winding_factor2 = convertStr(self.P_Fill.text())   
         ambient_temp    = convertStr(self.P_AmbT.text())  
         Tmax            = convertStr(self.P_MaxT.text())   
         L               = convertStr(self.P_Ind.text()) 
         Iac_peak        = convertStr(self.P_CurrentPeak.text())
         Iac_peak_fund   = convertStr(self.P_CurrentPeak_2.text())         
         P_CurrentAvg    = convertStr(self.P_CurrentAvg.text())
         Fundamental_Freq= convertStr(self.P_Fund.text())    
         Ac_Ripple       = float(convertStr(self.P_Ripple.text()))/100    # 0.1 = 10% Iac_peak 
         inverter_freq   = convertStr(self.P_Fsw.text())
         n_Results       = int(convertStr(self.P_Nres.text()) ) 
         max_temperature_deviation = convertStr(self.P_Dev.text())    
         n_min_itterations = int(convertStr(self.P_Nmin.text())) 
         Sort_by         = 10 # 10 equals volume
         n_cores         = int(convertStr(self.P_Stacked.text()) )  
         Current_density = convertStr(self.P_CurrDens.text()) 
         Max_W_L         = int(convertStr(self.P_Layers.text()))   
         PowderCore      = self.Powder.checkState()
         FerriteCore     = self.Ferrite.checkState()
         if(self.Height_Limited.checkState()):
          Height_Limited = convertStr(self.P_Height_Limited.text())         
         if(self.Diameter_Limited.checkState()):
          Diameter_Limited = convertStr(self.P_Diameter_Limited.text()) 
         if(self.AirGapLimit.checkState()):
          AirGapLimit = convertStr(self.P_AirGapLimit.text())
         if(self.Forced_Conv_Limited.checkState()):            
          P_Forced_Conv   = convertStr(self.P_Forced_Conv.text()) 

         if(self.LitzWire.checkState()):
          LitzWire[0] =self.LitzWire.checkState()
          LitzWire[1] =convertStr(self.P_Litz_Bundle_Diameter.text())/1000
          LitzWire[2] =(convertStr(self.P_Litz_strand_Diameter.text()))/1000
          LitzWire[3] =(convertStr(self.P_Litz_strands_2.text()))
          
         if(self.Heatsink.checkState()):           
          Heatsink        = convertStr(self.P_Heatsink.text()) 
         if(self.Corenumber.checkState()):        
          CoreNumber        = (self.P_Corenumber.text())+" "
          print CoreNumber
         if(self.Thermalwinding.checkState()):        
          Thermalwinding    = convertStr(self.P_Thermalwinding.text()) 

         
         FastThermal     = self.FastThermal.checkState()
         
         
         
         if PowderCore and (FerriteCore == 0):  
          csv_filename    = "CoreData.csv"
          #print P_CurrentAvg,P_Forced_Conv,LitzWire,Heatsink,FastThermal
          MainSheel_initalize(Sort_by,csv_filename,L,Iac_peak, Idc,Ac_Ripple, ambient_temp, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,P_CurrentAvg,P_Forced_Conv,LitzWire,Heatsink,FastThermal,CoreNumber,Thermalwinding,Iac_peak_fund)
         if FerriteCore and (PowderCore == 0):
          csv_filename    = 'Core_Ferrite.csv'
          MainSheel_initalize(Sort_by,csv_filename,L,Iac_peak, Idc,Ac_Ripple, ambient_temp, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,P_CurrentAvg,P_Forced_Conv,LitzWire,Heatsink,FastThermal,CoreNumber,Thermalwinding,Iac_peak_fund)

         
if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    myapp = TestWindow()
    myapp.show()
    sys.exit(app.exec_())
    



