# -*- coding: utf-8 -*-
"""
Created on Tue Aug 07 14:07:55 2012

@author: kl
"""
import math
import pylab #only neccesary for plot
from time import clock, time #just for telling time in output info

def Cu_resistivity(Operation_temp_C):
 #Mail from richard lund rho20 = 1.68 and alpha 0.0039 
 #ohm*m
 resistivity = 1.68*(1+0.0039*(Operation_temp_C-20))*10**-8
 return resistivity
 
def Rdc(cu_resistivity,Wire_O_D):
 #print "cu_resistivity",cu_resistivity,"Wire_O_D",Wire_O_D
 ohm = (cu_resistivity)/(math.pi*(Wire_O_D/2)**2)#wire_od is in meters while cu_res is in m 
 return ohm
 
def Rac(cu_resistivity,Freq,Wire_O_D,m1):
 Rdc_m = Rdc(cu_resistivity,Wire_O_D)
 cu_resistivity_m = cu_resistivity # m
 my_0  = 4*math.pi*10**-7

 #Skin and proximity effect a messy introduction by Richard Lund   
 Penetration_depth = math.sqrt(cu_resistivity_m/(math.pi*my_0*(Freq))) #in m
 Penetration_depth = Penetration_depth *100 #cm to m
 Wire_O_D_m = Wire_O_D*100 #from m to cm
 x = (Wire_O_D_m/2)/(Penetration_depth)
 M = x*((math.sinh(2*x)+math.sin(2*x))/(math.cosh(2*x)-math.cos(2*x))) 
 D = 2*x*((math.sinh(x)-math.sin(x))/(math.cosh(x)+math.cos(x)))
 m = m1 #number of layers
 Fr= M+(m**2-1)/3*D
 Rac_m=Rdc_m*Fr
 #print "x",x,"Penetration_depth",Penetration_depth,"Freq", Freq," cu_resistivity_m", cu_resistivity_m 
 #print "Fr",Fr,"Rac_m",Rac_m  
 return Rac_m    

Wire_O_D = 1.12/1000  # 1mm
cu_resistivity = Cu_resistivity(200)
Freq = 0
n = 0
plotx = []
ploty = []
plotz = []
plott = []

while n < 100:
 n = n+1
 Freq = Freq+1000
 plotx.append(Freq)
 ploty.append(Rac(cu_resistivity,Freq,Wire_O_D,5))#/Rdc(cu_resistivity,Wire_O_D))
 plotz.append(Rac(cu_resistivity,Freq,Wire_O_D,8))#/Rdc(cu_resistivity,Wire_O_D))
 plott.append(Rac(cu_resistivity,Freq,Wire_O_D,12))#/Rdc(cu_resistivity,Wire_O_D))

pylab.plot(plotx,ploty,label="Singel Layer")
pylab.plot(plotx,plotz,label="Two Layers")
pylab.plot(plotx,plott,label="Three Layers")
pylab.xlabel('Frequency [Hz]')
pylab.ylabel('Rac/Rdc')
pylab.legend(loc='upper left')
pylab.show()     