# -*- coding: utf-8 -*-
"""
Created on Wed Jun 27 10:02:40 2012

@author: kl
"""

import math
import pylab #only neccesary for plot

#"sjekker om string s er et tall trengs pga problemer med string objekter som f.eks 4.1 der innebygde funksjoner kun virker på unicode"
def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False
def search_item(main_table, row1, item):
 for line in main_table:
        if line[row1] == item: 
         return line
 return "Not found"
         
#tar en csv fil sepparer ved ; i strings eller number og returner en liste med lister
def read_csv(filename):
 data2= []
 for line in open(filename,'r'):
    data = []
    #"Er det verdier der?"
    if line.strip():
        "separer ved  ;"
        rows = line.strip().split(';') 
        for i, number in enumerate(rows):
          if is_number(number):
              #converts to a number
              data.append(float(number))
          else:
              data.append(number)            
        data2.append(data)        
    else:
        print "Error no data in csv"    

 return data2

def new_LIIlimit(Core,L,Iac,Idc,Max_correction):
 #Due to rounding effects and non linearity near sat maks was set to 50% of bsat   
 if Core[2] == 'Kool Mu ':
     Bmax = 1.05/2
 elif Core[2] == 'MPP ':
     Bmax = 0.75/2
 elif Core[2] == 'High Flux ':
     Bmax = 1.5/2
 elif Core[2] == 'XFlux ':
     Bmax = 1.6/2       
 else:
      print 'Error in LIIlimit material not found at index' 
 my_0 = 4*10**(-7)*math.pi
 mm_to_meter = 10**-9
 
 #print Bmax**2/(L*Imax**2), my_0*Core[1]*Max_correction/(Core[10]*mm_to_meter)
 #print "######################" 
 #Bmax^2/(L*Imax^2)> my_0*my_r/(volume * 10^-9 (due to mm))
 #Max_correction is the lowest allowed correction for my i.e 0.5 outside this range magnetics equations are unstable
 Imax = Iac+Idc
 if Bmax**2/(L*Imax**2) < my_0*Core[1]*Max_correction/(Core[10]*mm_to_meter):
  #print "killed by LIIlimit"  
  return 1
 else:   
  return 0
 
#Cu_resistivity ohm*cm
def Cu_resistivity(Operation_temp_C):
 #5-9 in section 5 inducter and flyback transformer design rho20 = 1.724 and alpha 0.0042
 #Mail from richard lund rho20 = 1.68 and alpha 0.0039 
 #ohm*cm
 resistivity = 1.68*(1+0.0039*(Operation_temp_C-20))*10**-6
 return resistivity
# Current_density A/cm^2    
def Current_density(Cu_resistivity):  
 Current_density = (1/Cu_resistivity)*10**-3 
 return Current_density

#cu_resistivity ohm*cm i want ohms in meters so x 100cm
#wire_od is in meters while cu_res is in cm 
def Rdc(cu_resistivity,Wire_O_D):
 #print "cu_resistivity",cu_resistivity,"Wire_O_D",Wire_O_D
 ohm = (cu_resistivity/100)/(math.pi*(Wire_O_D/2)**2)#wire_od is in meters while cu_res is in cm 
 return ohm

#Cu_resistivity is in cm
#Freq is in Hertz
#Wire_O_D is in meters
def Rac(cu_resistivity,Freq,Wire_O_D,):
 Rdc_m = Rdc(cu_resistivity,Wire_O_D)
 cu_resistivity_m = cu_resistivity*100 #from cm to m
 my_0  = 4*math.pi*10**-7

 #Skin and proximity effect a messy introduction by Richard Lund   
 Penetration_depth = math.sqrt(cu_resistivity_m/(math.pi*my_0*(Freq))) #in cm
 Wire_O_D_m = Wire_O_D*100 #from m to cm
 x = (Wire_O_D_m/2)/(Penetration_depth)
 print "x",x,"Penetration_depth",Penetration_depth,"Freq", Freq," cu_resistivity_m", cu_resistivity_m 
 M = x*((math.sinh(2*x)+math.sin(2*x))/(math.cosh(2*x)-math.cos(2*x))) 
 D = 2*x*((math.sinh(x)-math.sin(x))/(math.cosh(x)+math.cos(x)))
 m = 1 #number of layers
 Fr= M+(m**2-1)/3*D
 Rac_m=Rdc_m*Fr
 print "x",x,"Penetration_depth",Penetration_depth,"Freq", Freq," cu_resistivity_m", cu_resistivity_m 
 print "Fr",Fr,"Rac_m",Rac_m  
 return Rac_m     



#uses Al and L and returns the ceil of turns
def windings(Al,L): 
    # N = sqrt(L/(Al*10^-9))
 if Al != 0:   
  turns = math.sqrt(L / (Al*10**-9))
  return math.ceil(turns)
 else:
  return 0        


# Finds how much of the interior area that will be filled with wires not 100% correct due to using info from the csv which is different from the real values Magnetics has calculated for the winding area
def winding_factor(current_density, Current,main_table):
 print "test" 
 wire_diameter = Awg_finder(current_density, Current)
 print wire_diameter
 for Line in main_table:
   if Line[0] == "Part Number":
    Donothing = 0  
   else:
    print Line   
    ID = Line[6]*10**-3
    Max_window = pi*(ID/2)    
    wire_surface = pi*(wire_diameter/2)**2*Line[11] #Surface wire * turns 
    Winding_factor = Max_window/wire_surface 
    print Winding_factor
 return
#returns how much of the window is filled.

def fill_factor(Core_ID,Wire_O_D,turns):
 
 Core_ID = Core_ID/1000 #want meters and not mm
 #Area_window = pi * ID^2 in m
 Area_window = pi * (Core_ID)**2
 #Area_Wire
 Area_Wire = pi * Wire_O_D**2
 if Area_window != 0 and turns != 0:
  #print "Core_ID =",Core_ID , "Wire_O_D =",Wire_O_D     
  #print turns, Area_Wire, Area_window
  fill_fact = (turns * Area_Wire)/Area_window
  return fill_fact
 else:
  return 0





#This function modifes AL and My with dc-bias temp and ac-flux from magnetics S3-20 S3-24 s3-17 
#It takes inn 3 csv files which is based on magnetics tables 
#(Notes,Idc,ambient_temp,deltaB)  
def My_modifier(Material,Permability,Dc_bias_current,ambient_temp,Bpeak):
 #print "Material =",Material,"Permability =",Permability,"Idc =",Idc,"temp =",ambient_temp,"deltaB =",deltaB   
 #magnetics S3-17 
 Temperature_table = read_csv("Temperature_table.csv")
 #magnetics S3-20 
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 #magnetics S3-24 
 Ac_flux_table = read_csv("Ac_flux_table.csv")
#Line[2] = material
#line[1]= Permability  
  
 My_temperature_factor = 0
 My_dc_bias_factor = 0
 My_Ac_flux_factor = 0  
 for row in Temperature_table:
  #matches Materials and permability in the two tables      
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   My_temperature_factor =  row[2]+row[3]*ambient_temp+row[4]*ambient_temp**2+row[5]*ambient_temp**3   
   #assumed the calced valued should be abs() since figure says +- 
   My_temperature_factor = 1 - abs(My_temperature_factor)
   #there is only one match per line so avoids unnecesary lines
   break
 for row in Dc_bias_table:
  #matches Materials and permability in the two tables      
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   #My_dc_bias_factor is assumed to be calced as My_dc_bias_factor*otherfactors see middle of page 2-11 Magnetics 2011
   My_dc_bias_factor =  row[2]+row[3]*Dc_bias_current+row[4]*Dc_bias_current**2+row[5]*Dc_bias_current**3+row[6]*Dc_bias_current**4         
   #there is only one match per line so avoids unnecesary lines
   break
 for row in Ac_flux_table:
  #matches Materials and permability in the two tables   
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   My_Ac_flux_factor =  row[2]+row[3]*Bpeak+row[4]*Bpeak**2+row[5]*Bpeak**3+row[5]*Bpeak**4  
   #assumed the calced valued should be abs() since figure says +- 
   My_Ac_flux_factor = 1 - abs(My_Ac_flux_factor)
   #there is only one match per line so avoids unnecesary lines
   break   
 My_correction = My_temperature_factor *  My_dc_bias_factor * My_Ac_flux_factor 
 #The correction factor is sent back to the program
 #the large limits is due to the unstability before the itterating process obtain the correct value
 if My_correction > 0.1 and My_correction <3:        

  return My_correction 
 else:
  return 0
 #selects wire size from awg table based on current density
 #Returns minimum Wire O.D 
def Wire_selector(Irms,current_density, Notes):
 #magnetics S3-28
 Wire_table = read_csv("WireTable.csv")
 #Wiretable is ordred by largest first easier to reverse it 
 Wire_table.reverse()    
 
 Notes.append(Wire_table)

 Collum1 = 0
 Collum2 = 0
 # Interpolates btw collums to get the current density this chooses which collums 
 if current_density < 200 or current_density>800:
     #print "Current density error out of bonds with: " , current_density
     return 0
 elif current_density < 400:
  Collum1 = 4
  Collum2 = 5
 elif current_density < 500:
  Collum1 = 5
  Collum2 = 6 
 elif current_density < 600:
  Collum1 = 6
  Collum2 = 7  
 elif current_density < 800:
  Collum1 = 7
  Collum2 = 8
 
 #finding the position to interpolate at
 delta_Curr_cappacity = (current_density - Wire_table[44][Collum1])/(Wire_table[44][Collum2]-Wire_table[44][Collum1])

 Wire_O_D = 0
#works throught the wire table looking for the first point the wire is large enouht to take the current
 for Line in Wire_table:
  Curent_cap_at_AWG = Line[Collum1]+ delta_Curr_cappacity*(Line[Collum2]-Line[Collum1])  
  if Irms <Curent_cap_at_AWG:
   #print "Irms=",Irms,"Current cap=", Curent_cap_at_AWG,"Awg =",  Line[0]
   Wire_O_D = Line[2]   
   break
 if Wire_O_D == 0 or Wire_O_D == "wire O.D":
  print "Wire_selector Did not find a wire which fit current to large"
  return 0
 else:
  Wire_O_D = Wire_O_D/100 #transforms from cm to m        
  return Wire_O_D


 
#takes in a core with dims in mm and returns MLT in m 
def MLT(core):
 #Mean length per turns bad approx
 #lengde = 2*(Od-Id)+2*h in main table lengths are in mm so divide by 1000 to get m
 Mlt = 2*((core[5]-core[6])+core[7])/1000 
 return Mlt  

#Returns copperlosses in W 
def CopperLosses(Notes,Core, Wire_O_D,cu_resistivity,Idc,Iac_peak,turns,Ac_Ripple,Fundamental_Freq,inverter_freq):
 #print "cu_resistivity =",cu_resistivity  
 #cu_resistivity ohm*cm i want ohms in meters so x 100cm
 if(Wire_O_D) > 0 :
  Rdc_m     = Rdc(cu_resistivity,Wire_O_D)#wire_od is in meters while cu_res is in cm 
  Rac_m     = Rac(cu_resistivity,Fundamental_Freq,Wire_O_D)
  Rripple_m = Rac(cu_resistivity,inverter_freq,Wire_O_D)
 else: 
  return 0
 Notes.append("Mean length per turn is not good"), "P = R*I^2 uses Imax/sqrt(2)"
 total_length = MLT(Core) * turns # this is in meters
 #P = R*I^2
 #print "CopperLosses Ohm m = ",  ohm 
 print "Rdc_m",Rdc_m,"Rac_m",Rac_m,"Rripple_m",Rripple_m 
 P1 = total_length*Rdc_m*(Idc**2)
 P2 = total_length*Rac_m*((Iac_peak/math.sqrt(2))**2)
 P3 = total_length*Rripple_m*((Ac_Ripple/math.sqrt(2))**2)
 print "Pdc", P1,"Pac", P2, "Pripple", P3, "totallength", total_length
 return P1+P2+P3

#Returns corelosses in W takes in freq and Tesla 
def CoreLosses(Notes,Core,B_flux,Freq):
 #print "B_flux", B_flux, "Freq",Freq 
 Loss_data = read_csv("CoreLoss_data.csv")
 #sets default to 0 incase data isnt found   
 #The reason to continue itterating is that the core data which isnt found is skipped..
 Ptot = 0   
 for row in Loss_data:
  #Matches loss data to the correct material and permability   
  if Core[1] == row[1] and Core[2] == row[0]:
   a = row[2]
   b = row[3]
   c = row[4]
   #P is in mwatt pr cm^3  magnetics 2-8
   Ploss = a*(B_flux**b)*((Freq/1000)**c)
   #inductor and flyback 5-8 most likely if ploss<100mw/cm^3 loss limited
  # if(Ploss<100):
  #  Core[13] = Core[13]+"[Might not be loss limted due to ploss<100mw/cm^3]"
   #Ptotally  core[10] is volume in mm^3 --> 10**-3 so its cm^3   
   Ptot = Ploss * Core[10]*10**-3
   # mW->W
   Ptot = Ptot/1000
   break
 return Ptot

#takes in a core and returns surface_area in m^2
def new_core_surface_with_windings(Core):
 #Upper and lower then sides this is in mm^2   
 Surface_area = 2*(Core[5]**2-Core[6]**2)*math.pi+(2*math.pi*Core[5]+2*math.pi*Core[6])*Core[7]   
 #surface area in m^2   
 Surface_area = Surface_area*10**-6
 return Surface_area 


#Takes a surface in m^2 and Powerloss in W returns temp increas in C 
def new_temperature_increase(Surface,Powerloss):   
 #magnetics 2-7 ((loss in mw)/surface(cm^2))^0.833
 temp_increase = ((Powerloss*1000)/(Surface*10000))**0.833
 #print "Surface",Surface,"Powerloss",Powerloss,"temp_increase",temp_increase   
 return temp_increase

#bias in A*T/cm  L-e is path length if any input parameters = 0 returns 0
#returns h in cm
def DC_Bias(N,Idc,le):
 #magnetics 2-1 and example at 2-11
 if N != 0 and le != 0 and Idc != 0:
  Hdc = N/le*Idc 
  #print "Hdc =",Hdc, "N = ",N ,"le =", le, "Idc =", Idc
  return Hdc
 else:
  return 0
  
#takes in turns, ac current peak, core length, my ie m_r*my_0
#returns delta h in cm
def Bmax(N,Iac_peak,le,My):
 #sinusoidal function, so delta_I = 2x Iac_peak   
 delta_I = 2*Iac_peak    
# deltaB = N/le*(Iacmax-Iacmin)/2*my
 delta_h = N/le*(delta_I)
 #print "My =",My,"delta_h",delta_h,"le =", le,"delta_I", delta_I
 # *100 because tesla need to be in meteres while delta h is in cm
 Bpeak = 0.5*My*delta_h*100
 return Bpeak

#This takes a specific core and try to make it work.
#Includes temperature change  
def itterating_loop(Core,Idc,Iac_peak,Ac_Ripple,L,Fundamental_Freq,inverter_freq,Tmax,CoreData):
 Notes = []
 Ac_Ripple_current = Iac_peak*Ac_Ripple
 my_0  = 4*math.pi*10**-7   
 my_core  = Core[1]#inital permability for the material
 turns = 1 #Need a starting point for the number of windings
 le = Core[8]*10**-1  #path length in cm    core[8] is in mm
 Material = Core[2] #Mpp highflux etc
 Al = Core[4]  
 Temperature = ambient_temp
 delta_temperature = 1
 Alnew = 0
 Copperloss = 0
 CoreLoss = 0
 Core_temperature = 0
 my_correction = 1
####################################################### 
#Before itterating
 my_initial = my_0*my_core
 my = my_initial
 #checking if the core is inside the pysical limits
 min_correction = 0.5  #Bmax^2 <LI^2*my/(Vc) the minimum core size is at correction 0.5
  
 if (new_LIIlimit(Core,L,Iac_peak,Idc,min_correction)==1): 
  return 0

 #print "DeltaB =" ,deltaB
####################################################### 
#After itterating 
 H = 0
 Bpeak = 0
 
 plot_x =[]
 plot_y =[]
 plot_z =[] 
  
 n = 0
 while (abs(delta_temperature) > 0.1 or n<200):
  n = n+1
  
  
  my_correction = My_modifier(Material,my_core,H,Temperature,Bpeak)  
  H = DC_Bias(turns,Idc,le)
  Bpeak = Bmax(turns,Iac_peak,le,my)
  Alnew = Al*my_correction
  my = my_initial*my_correction
  turns = windings(Alnew,L) 
  cu_resistivity = Cu_resistivity(Temperature)
  current_density= Current_density(cu_resistivity) 
  Wire_O_D = Wire_selector(Iac_peak,current_density, Notes)
##Losses
  Copperloss           = CopperLosses(Notes,Core, Wire_O_D,cu_resistivity,Idc,Iac_peak,turns,Ac_Ripple_current,Fundamental_Freq,inverter_freq)
  CoreLoss_fundamental = CoreLosses(Notes,Core,Bpeak,Fundamental_Freq)
  CoreLoss_inverter    = CoreLosses(Notes,Core,Bpeak*Ac_Ripple,inverter_freq)
  CoreLoss             = CoreLoss_fundamental+ CoreLoss_inverter
  Powerloss            = CoreLoss + Copperloss
##Temperature
  Surface = new_core_surface_with_windings(Core) 
  Core_temperature  = new_temperature_increase(Surface,Powerloss)  
  delta_temperature = (Temperature - ambient_temp - Core_temperature)
  Temperature = ambient_temp + Core_temperature
  #print Temperature
  
  plot_x.append(n)
  plot_y.append(turns)
  plot_z.append(Powerloss)  
  #print "Core_temperature =", Core_temperature,"Temperature =",Temperature,"delta_temperature =",delta_temperature,"my_correction =", my_correction   
  #print "n =",n,"Bpeak =",Bpeak, "delta_temperature",delta_temperature   
  #print "turns =", turns, "Alnew =", Alnew, "Copperloss", Copperloss, "CoreLoss",CoreLoss, "Core_temperature", Core_temperature      
  #print ambient_temp  
  #print "###################################"
  #print "###################################"
  if(n>201):
   #print "n =",n,"Bpeak =",Bpeak, "delta_temperature",delta_temperature   
   #print "turns =", turns, "Alnew =", Alnew, "Copperloss", Copperloss, "CoreLoss",CoreLoss, "Core_temperature", Core_temperature      
   #print "error error to large n"
   return 0

 pylab.plot(plot_x,plot_y)
 #pylab.plot(plot_x,plot_z) 

 
 if(Copperloss == 0) or (Tmax<Temperature):
  return 0 
 else:
  print "n =",n,"Bpeak =",Bpeak, "delta_temperature",delta_temperature   
  print "turns =", turns, "Alnew =", Alnew, "Copperloss", Copperloss, "CoreLoss",CoreLoss, "Core_temperature", Core_temperature      
  pylab.show()  
  return 1


def main(main_list,L,Iac_peak, Idc,Ac_Ripple, ambient_temp, Fundamental_Freq,inverter_freq,Tmax):
 Notes = [] 
 itemsfound = []   
 CoreData = []
 n = 0
 n1 = 0 
 for line in main_list:
  n1 = n1+1   
  
  if line[0] != "Part Number":   
      
   #itterating_loop(main_list[40],Idc,Iac_peak,L,freq,Tmax)
   bool_found = itterating_loop(line,Idc,Iac_peak,Ac_Ripple,L,Fundamental_Freq,inverter_freq,Tmax,CoreData)
   #print n1, "###################"
   if bool_found == 1:
    Notes.append(CoreData)   
    print n1, "###################"   
    n = n+1
   if n == 1:
    break
 return Notes

Idc             = 0.5
winding_factor2 = 0.4  #2-2 and 2-6 typical max value
ambient_temp    = 80.0  # just so i get something
Tmax            = 200   #Core temp+ambient_temp
L               = 0.0006
Iac_peak        = 15  #Fundamental frequency maximum secure value is 26.6A due the wire table frequency is assumed to be low so Rac = Rdc
Fundamental_Freq= 60.0
csv_filename    = 'Book1.csv'
Ac_Ripple       = 0.03 #Atm in % of Iac_peak  #assumed to be so small that it dont severely affect B but only causes conductor losses
inverter_freq   = 10000


main_list = read_csv(csv_filename) 
Notes = main(main_list,L,Iac_peak, Idc,Ac_Ripple, ambient_temp, Fundamental_Freq,inverter_freq,Tmax)
