#!/usr/bin/env python
# -*- coding: utf-8 -*-

import math
from pylab import * #only neccesary for plot
from time import clock #just for telling time in output info
from Thermal import Thermal_main
from scipy.optimize import fsolve

#this function checks if s is a number, this function was neccesary due to unicode problems which did not support built in checks
def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False
def is_Powder(Material):
 if((Material == 'R ')or(Material == 'P ')or(Material == 'F ')):
  return 0
 else: 
  return 1 
        
def convertStr(s):
 """Convert string to either int or float."""
 try:
 	ret = int(s)
 except ValueError:
 	#Try float.
 	ret = float(s)
 return ret
        
def Plot(X,Y):
 pylab.plot(X,Y)
 pylab.show()
 return

 
#This function underestimate at small sizes but is very accurate at larger OD
#Input Core, Diameter in m and Max layers
#Output list with windings in each layers or 0
def Layers(Core,Wire_O_D,Maxlayers,turns):
 turns_initial = turns
 Layers = [] 
 NewID = Core[6]*10**-3 #this is in mm want meters
 while ((NewID-Wire_O_D)>Wire_O_D)and(len(Layers)<Maxlayers):
  if(NewID == Core[6]*10**-3):#initial middle
   NewID = NewID-(Wire_O_D/2)
  else:
   NewID = NewID-Wire_O_D  
  length = math.pi*2*(NewID/2)/(1.1**(len(Layers)+1))
  Layer_turns = floor(length/Wire_O_D)
  if(turns-Layer_turns)>0:
   Layers.append(math.floor(Layer_turns))  
   turns = turns-Layer_turns
  else:
   Layers.append(turns)
   break
 if (Layers) and (sum(Layers)==turns_initial):   
  return Layers
 else:
  return [0] 
 return
#Imports a csv file named with the input filename located in the same folder as the script
def read_csv(filename):
 data2= []
 for line in open(filename,'r'):
    data = []
    #Checks if theres values there
    if line.strip():
        "separer ved  ;"
        rows = line.strip().split(';')
        for i, number in enumerate(rows):
          if is_number(number):
              #converts to a number
              data.append(float(number))
          else:
              data.append(number)            
        data2.append(data)        
    else:
        print "Error no data in csv"    

 return data2
def write_log(filename,Data):
 File = open(filename,'w')
 for line in Data:
  for line2 in line:
   for line3 in line2:
    s = str(line3)+";"    
    File.writelines(s)
   File.write("\n")
  File.write("\n")
 File.close
 return
#Creates a list of information from the input the data is not sent back but saved in CoreData list
def AddData(CoreData,Core,H,Bpeak,Alnew,my,turns,Wire_O_D,Copperloss,CoreLoss,Core_temperature,Temperature,plot,current_density,my_correction,fillfactor,inverter_freq,Surface,Layer,Al_from_leak,Idc, le_gap,Fr,FastThermal):   
 CoreD  = []
 mWcm3 = 1000*CoreLoss/(Core[10]/1000) #core 10 = volume in mm^3 want cm^3 
 Loss_data = read_csv("CoreLoss_data.csv")
 Temperature_table = read_csv("Temperature_table.csv")
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 Ferrite_loss    = read_csv("Ferrite_Loss_steinmetz.csv")
 Ferrite_loss_t  = read_csv("Ferrite_Loss_temp.csv") 
 Ferrite_my_t  = read_csv("Ferrite_Permability_Temp.csv")
 Ferrite_my_f  = read_csv("Ferrite_Permability_Freq.csv")

 averageL = turns**2*Alnew[0]/my_correction*10**-9*My_mod_powder(Core[2],Core[1],Idc,Temperature,inverter_freq,Temperature_table,Dc_bias_table,Frequency_table)
 
 Data1  = ["Core Data",Core,"-" ]
 Data2  = ["H ",H,"[A*T/cm]"]
 Data3  = ["Bpeak Ripple",Bpeak[0],"[T]"]
 Data4  = ["Al with leakage ind",Alnew[0],"[nH/N^2]" ]
 Data5  = ["Turns",turns,"[-]"]
 Data6  = ["Wire D",Wire_O_D,["m"]]
 Data7  = ["Copperloss",Copperloss[0], "[W]" ]
 Data8  = ["CoreLoss ",CoreLoss[0],"[W]"]
 Data81 = ["Total Loss",Copperloss[0]+CoreLoss[0],"[W]"] 
 Data82 = ["Core",mWcm3[0],"[mW/cm^3]"]
 Data9  = ["Core Temperature",Core_temperature[0],"C"]
 Data10 = ["Temperature",Temperature[0],"C"]
 Data11 = ["plot",plot]
 Data12 = ["Wire Area",(Wire_O_D/2)**2*math.pi,"m^2"] 
 Data13 = ["Current Density",current_density,"[A/cm^2]"]
 Data15 = ["My Correction",my_correction[0],"-"]
 Data16 = ["Fill factor",fillfactor,"-"]
 Data17 = ["Peak L",turns**2*Alnew[0]*10**-9,"H"]
 Data175 = ["Average L",averageL[0],"-"] 
 Data18 = ["Volume",Core[10],"[mm^3]"]
 Data19 = ["Inverter-Freq",inverter_freq/1000,"[kHz]"]
 
 Data20 = ["Surface",Surface,"[m^2]"]
 Data21 = ["Winding Layers",Layer,"[-]"]
 Data22 = ["Al from leakage L",Al_from_leak,"[H]"]
 Data23 = ["Gap length", le_gap,"[cm]" ]
 Data24 = ["Fr ripple", Fr,"-" ]
 Data25 = ["Wire Neccesary", MLT(Core,Wire_O_D,Layer)*turns,"[m]"  ]
 
 CoreD.append(Data1)
 CoreD.append(Data2)
 CoreD.append(Data3)
 CoreD.append(Data4)
 CoreD.append(Data5)
 CoreD.append(Data6)
 CoreD.append(Data7)
 CoreD.append(Data8)
 CoreD.append(Data81)
 CoreD.append(Data82) 
 CoreD.append(Data9)
 CoreD.append(Data10)
 CoreD.append(Data11)
 CoreD.append(Data12) 
 CoreD.append(Data13)
 CoreD.append(Data15)
 CoreD.append(Data16)
 CoreD.append(Data17)
 CoreD.append(Data175)
 CoreD.append(Data18)
 CoreD.append(Data19)
 CoreD.append(Data20)
 CoreD.append(Data21)
 CoreD.append(Data22)
 CoreD.append(Data23)
 CoreD.append(Data24)
 CoreD.append(Data25)
 
 CoreData.append(CoreD)
 return

#Maximum B-fluks the materials can take and still be in the linear the maximum values are from magnetics
def Bmaximum(Material):
 Bmax = 0
 if Material == 'Kool Mu ':
     Bmax = 1.05
 elif Material == 'MPP ':
     Bmax = 0.75
 elif Material == 'High Flux ':
     Bmax = 1.5
 elif Material == 'XFlux ':
     Bmax = 1.6
 elif Material == 'L ':
     Bmax = 0.42
 elif Material == 'R ':
     Bmax = 0.47    
 elif Material == 'P ':
     Bmax = 0.47       
 elif Material == 'F ':
     Bmax = 0.47  
 elif Material == 'T ':
     Bmax = 0.53  
 else:
      print Material 
      print 'Bmaximum material not found' 
 return Bmax

#leakage flux for toroid powder core, 50% deviation posible depending on winding configuration
def Leakage_Ind(N,Ae,le,Material,lg):
 LLx = 0   
 if(is_Powder(Material)):   
  LLx = 0.292*N**1.065*Ae/(le) # Nb the reason le isnt transfered to meters is the equation bellow
  #the equation above yields uH this transfers to H    
  LLx = LLx*10**-6  
 else:
  I_D          = math.sqrt(Ae/math.pi)#inner diameter   
  Cirumference = 2*math.pi*I_D
  G            = Cirumference/4 # assuming a square winding gap and transforming this into a C core  
  F            = (1+lg/math.sqrt(Ae)*np.log(2*G/lg))
  LLx          = (F-1)*((N**2*Ae*4*math.pi*10**-7)/le)
  #print "F " ,F ,"LLx ",LLx,(N**2*Ae*4*math.pi*10**-7)/le
     
 return LLx

#Returns true if the core physical dimensions can't handle the L I ripple peak
#returns false if it cant      
def LIIlimit(Core,L,Ir_peak,Max_correction):
 Material = Core[2]   
 Bmax = Bmaximum(Material)   
 my_0 = 4*10**(-7)*math.pi
 mm_to_meter = 10**-9 
 Volume = Core[10]
 if Bmax**2/(L*Ir_peak**2) < my_0*Core[1]*Max_correction/(Volume*mm_to_meter):
  #print "killed by LIIlimit"  
  return 1
 else:
  return 0
 
#returns Cu_resistivity ohm*m based on temperature
def Cu_resistivity(Operation_temp_C):
 #Mail from richard lund rho20 = 1.68 and alpha 0.0039 
 #ohm*m
 resistivity = 1.68*(1+0.0039*(Operation_temp_C-20))*10**-8
 return resistivity

# returns Current_density A/cm^2 based on Cu_resistivity   
#def Current_density(Cu_resistivity):  
# Current_density = (1/Cu_resistivity)*10**-5 
# return Current_density


#Input cu_resistivity[ohm/m] and Wire_O_D[m]
#Returns Rdc in ohm/m 
def Rdc(cu_resistivity,Wire_O_D):
 #print "cu_resistivity",cu_resistivity,"Wire_O_D",Wire_O_D
 ohm = (cu_resistivity)/(math.pi*(Wire_O_D/2)**2)#wire_od is in meters while cu_res is in m 
 return ohm

#Cu_resistivity is in meters Freq is in Hertz Wire_O_D is in meters
#Returns Rac in ohm/m based on skin effect
def Rac(cu_resistivity,Freq,Wire_D,N_Layers,Litz):
 if(Litz[0]==2):
  N_Layers = N_Layers * math.ceil(math.sqrt(Litz[3]))  
  equiDcDiameter = math.sqrt((Wire_D**2.0*math.pi*Litz[3])/math.pi)
  Wire_D = Litz[2]
 else:
  equiDcDiameter = Wire_D
  
 Rdc_m = Rdc(cu_resistivity,equiDcDiameter)
 cu_resistivity_m = cu_resistivity # m
 my_0  = 4*math.pi*10**-7

 #Skin and proximity effect a messy introduction by Richard Lund   
 Penetration_depth = math.sqrt(cu_resistivity_m/(math.pi*my_0*(Freq))) #in m
 Penetration_depth = Penetration_depth*100#from m into cm 
 Wire_O_D_m = Wire_D*100 #from m to cm
 
 x = (Wire_O_D_m/2)/(Penetration_depth)
 #print "x",x,"cu_resistivity",cu_resistivity
 M = x*((math.sinh(2*x)+math.sin(2*x))/(math.cosh(2*x)-math.cos(2*x))) 
 D = 2*x*((math.sinh(x)-math.sin(x))/(math.cosh(x)+math.cos(x)))
 m = N_Layers #number of layers
 Fr= M+(m**2-1)/3*D
 #print "Fr",Fr
 Rac_m=Rdc_m*Fr
 #print "x",x,"Penetration_depth",Penetration_depth,"Freq", Freq," cu_resistivity_m", cu_resistivity_m 
 #print "Fr",Fr,"Rac_m",Rac_m  
 return [Rac_m,Fr]     
 
#uses Al and L and returns the ceil of turns if Al=0 returns 0
def Turns(Al,L): 
    # N = sqrt(L/(Al*10^-9)) 
 if Al != 0:   
  turns = math.sqrt(L / (Al*10**-9))
  return math.ceil(turns)
 else:
  return 0        

# Finds how much of the interior area that will be filled with wires not 100% correct due to using info from the csv which is different from the real values Magnetics has calculated for the winding area
def fill_factor(Core_ID,Wire_O_D,turns):
 
 Core_ID = Core_ID/1000 #want meters and not mm
 #Area_window = pi * ID^2 in m
 Area_window = math.pi * (Core_ID)**2
 #Area_Wire
 Area_Wire = math.pi * Wire_O_D**2
 if Area_window != 0 and turns != 0:
  #print "Core_ID =",Core_ID , "Wire_O_D =",Wire_O_D     
  #print turns, Area_Wire, Area_window
  fill_fact = (turns * Area_Wire)/Area_window
  return fill_fact
 else:
  return 0

#This function modifes AL and My with dc-bias temp and ac-flux from magnetics S3-20 S3-24 s3-17 
#It takes inn 3 csv files which is based on magnetics tables 
def My_mod_Ferrite(Material,my_core,Temperature,inverter_freq,Ferrite_my_f,Ferrite_my_t):
 #Perm vs freq
 inverter_freq = inverter_freq/1000
 permT = 0
#I choose my material to not be freq dependent and only temp.
# if(Material == 'P ')or(Material == 'R '):
#  permf = ((Ferrite_my_f[2][2]+ Ferrite_my_f[2][3]*inverter_freq+Ferrite_my_f[2][4]*inverter_freq**2+Ferrite_my_f[2][5]*inverter_freq**3+Ferrite_my_f[2][6]*inverter_freq**4)/(1+Ferrite_my_f[2][7]*inverter_freq+Ferrite_my_f[2][8]*inverter_freq**2+Ferrite_my_f[2][9]*inverter_freq**3+Ferrite_my_f[2][10]*inverter_freq**4))**0.5 
# elif(Material == 'F '):
#  permf = Ferrite_my_f[3][2]+Ferrite_my_f[3][3]*inverter_freq**1+Ferrite_my_f[3][4]*inverter_freq**2++Ferrite_my_f[3][5]*inverter_freq**3++Ferrite_my_f[3][6]*inverter_freq**4++Ferrite_my_f[3][7]*inverter_freq**5++Ferrite_my_f[3][8]*inverter_freq**6++Ferrite_my_f[3][9]*inverter_freq**7
#μ = a + bT + cT2 + dT3 + eT4 + fT5 + gT6 + hT7 + iT8
 if(Material == 'R '):
  permT = Ferrite_my_t[1][2]+Ferrite_my_t[1][3]*Temperature**1+Ferrite_my_t[1][4]*Temperature**2+Ferrite_my_t[1][5]*Temperature**3+Ferrite_my_t[1][6]*Temperature**4
 elif(Material == 'P '):
  permT = Ferrite_my_t[2][2]+Ferrite_my_t[2][3]*Temperature**1+Ferrite_my_t[2][4]*Temperature**2+Ferrite_my_t[2][5]*Temperature**3+Ferrite_my_t[2][6]*Temperature**4     
 elif(Material == 'F '):
  permT = Ferrite_my_t[3][2]+Ferrite_my_t[3][3]*Temperature**1+Ferrite_my_t[3][4]*Temperature**2+Ferrite_my_t[3][5]*Temperature**3+Ferrite_my_t[3][6]*Temperature**4     
 else:
  print "Error material permaiblity adjustment not found" 
 return permT/my_core  

#Dc_bias_current is amp turns / cm
def My_mod_powder(Material,Permability,H,Temperature,inverter_freq,Temperature_table,Dc_bias_table,Frequency_table):  
 inverter_freq = inverter_freq + 0.001   #just making it into a floating point due to permability messes things up when dividing by 10^6
 inverter_freq = inverter_freq / 1000000
 inverter_freq = inverter_freq - 0.001/1000000
 #print "Material =",Material,"Permability =",Permability,"Idc =",H,"temp =",Temperature   
 #magnetics S3-17 
 Temperature_table = read_csv("Temperature_table.csv")
 #magnetics S3-20 
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 
#Line[2] = material
#line[1]= Permability  
 My_correction         = 0.000001
 My_temperature_factor = 0.000001
 My_dc_bias_factor     = 0.000001
 Frequency_factor      = 0.000001
 
 for row in Temperature_table:
  #matches Materials and permability in the two tables      
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   My_temperature_factor =  row[2]+row[3]*Temperature+row[4]*Temperature**2+row[5]*Temperature**3   
   #assumed the calced valued should be abs() since figure says +- 
   My_temperature_factor = 1 + (My_temperature_factor)
   #there is only one match per line so avoids unnecesary lines
   break
 for row in Dc_bias_table:
  #matches Materials and permability in the two tables      
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   #My_dc_bias_factor is assumed to be calced as My_dc_bias_factor*otherfactors see middle of page 2-11 Magnetics 2011
   My_dc_bias_factor =  row[2]+row[3]*H+row[4]*H**2+row[5]*H**3+row[6]*H**4         
   #there is only one match per line so avoids unnecesary lines
   break
 #The correction factor is sent back to the program
 for row in Frequency_table:
  #matches Materials and permability in the two tables      
  if Material == row[0] and Permability == row[1]:  
   #My = a+b*T+c*T^2+d*T^3 Magnetics 3-17
   #My_dc_bias_factor is assumed to be calced as My_dc_bias_factor*otherfactors see middle of page 2-11 Magnetics 2011
   #print Frequency_factor, Material,Permability,inverter_freq
   Frequency_factor = row[2]+row[3]*inverter_freq+row[4]*inverter_freq**2+row[5]*inverter_freq**3+row[6]*inverter_freq**4         
   Frequency_factor = 1 + Frequency_factor
   #there is only one match per line so avoids unnecesary lines
   break 
 #print "My_dc_bias_factor",My_dc_bias_factor
 #print My_temperature_factor,My_dc_bias_factor,Frequency_factor
# if(My_dc_bias_factor<0.4):
#  My_dc_bias_factor = 0.4 
 if(My_dc_bias_factor<0.9):
  My_dc_bias_factor = My_dc_bias_factor+0.1
 else:
  My_dc_bias_factor = 1
 if(My_dc_bias_factor <0.2):
  My_dc_bias_factor = 0.2
  print "Warning My_dc_bias_factor set to 0.2 to high current?"

 My_correction = My_temperature_factor*My_dc_bias_factor*Frequency_factor

 #the large limits is due to the unstability before the itterating process obtain the correct value
 if My_correction > 0.001 and My_correction <100:        
  return My_correction 
 else:
  return 0
 
  
##checks standard wires and return wireD of closest one
def Wire_selector(Irms,current_density,Wire_standard,Litz):
 if(Litz[0]==2): 
  return Litz[1] #Bundle Diameter
 else:
  current_density = current_density/100 #from cm^2 to mm^2
  MinArea = (Irms-0.001+0.001)/current_density  # ampere / (ampere/cm^2) need to trick python into using float
  Area    = 0
  Wire_O_R = (MinArea/math.pi)**0.5
  Wire_O_D = 2*Wire_O_R
  Wire_O_D = Wire_O_D*10**-3
  return Wire_O_D 
#### to select from standard not used
# for line in Wire_standard:
#  if(line[0]>MinArea): 
#   Area = line[0]
#   break
# Wire_O_R = (Area/math.pi)**0.5
# Wire_O_D = 2*Wire_O_R
# Wire_O_D = Wire_O_D*10**-3
# return Wire_O_D
 
#takes in a core with dims in [mm] and returns MLT in [m] strong approximation
def MLT(core,Wire_O_D,N_Layers):
 Mlt = 0.8*(core[5]+2*core[7])/1000
 return Mlt  

#Returns copperlosses in [W] 
def CopperLosses(Core, Wire_O_D,cu_resistivity,Idc,Iac_peak,CurrentAvg,turns,Ac_Ripple_avg,Fundamental_Freq,inverter_freq,N_Layers,Litz):
 
 #cu_resistivity ohm*cm i want ohms in meters so x 100cm
 if(Wire_O_D) > 0 :
  Rdc_m     = Rdc(cu_resistivity,Wire_O_D)#wire_od is in meters while cu_res is in cm 
  [Rac_m,Fr2]     = Rac(cu_resistivity,Fundamental_Freq,Wire_O_D,N_Layers,Litz)
  [Rripple_m,Fr]  = Rac(cu_resistivity,inverter_freq,Wire_O_D,N_Layers,Litz)
  #print "RDC", Rdc_m,"Rac",Rripple_m
 else:
  print "Wire_O_D = 0"   
  return
 total_length = MLT(Core,Wire_O_D,N_Layers) * turns # this is in meters
 #print "total_length", total_length,Fr,Fr2 
 #P = R*I^2
 #print "CopperLosses Ohm m = ",  ohm 
 #print "Rdc_m",Rdc_m,"Rac_m",Rac_m,"Rripple_m",Rripple_m 
 P1 = total_length*Rdc_m*(Idc**2)
 P2 = total_length*Rac_m*((CurrentAvg)**2)
 P3 = total_length*Rripple_m*((Ac_Ripple_avg)**2)
 #print "Pdc", P1,"Pac", P2, "Pripple", P3, "totallength", total_length
 return [P1+P2+P3,Fr]

#Returns corelosses in W takes in freq and Tesla very low core losses bellow 25khz and even at 100khz for some materials
def CoreLosses(Core,T,B_flux,Freq,Loss_data,Ferrite_loss,Ferrite_loss_t):
 Material = Core[2]
 Freq = Freq/1000 #just to make it into Khz  
 a = 0
 b = 0
 c = 0
 d = 0
 e = 0
 f = 0
 g = 0
 h = 0
 normalized_power_loss = 1 
 #print "B_flux", B_flux, "Freq",Freq 
 #sets default to 0 incase data isnt found   
 #The reason to continue itterating is that the core data which isnt found is skipped..
 if(is_Powder(Material) == 0):
  for row in Ferrite_loss:
   if(Material == row[0]):
    a = row[2]
    b = row[3]
    c = row[4]
    break
  for row in Ferrite_loss_t:
   if(Material == row[0]):
    d = row[1]
    e = row[2]
    f = row[3]
    g = row[4]
    h = row[5]
    normalized_power_loss = d + e*T+f*T**2+g*T**3+h*T**4
    #print Material, normalized_power_loss
    if(normalized_power_loss < 0 or normalized_power_loss>10):  
     print "normalized_power_loss error =", normalized_power_loss
     normalized_power_loss = 0  
 else:
  Ptot = 0   
  for row in Loss_data:
   #Matches loss data to the correct material and permability   
   if Core[1] == row[1] and Core[2] == row[0]:
    a = row[2]
    b = row[3]
    c = row[4]
    break
    #P is in mwatt pr cm^3  magnetics 2-8
 Ploss = a*(B_flux**b)*((Freq)**c)
    #inductor and flyback 5-8 most likely if ploss<100mw/cm^3 loss limited
    # if(Ploss<100):
    #  Core[13] = Core[13]+"[Might not be loss limted due to ploss<100mw/cm^3]"
    #Ptotally  core[10] is volume in mm^3 --> 10**-3 so its cm^3   
 Ptot = Ploss *Core[10]*10**-3*normalized_power_loss
    # mW->W
 Ptot = Ptot/1000
 if(a == 0):
  print "Error in corelosses"
 return Ptot

#takes in a core and returns surface_area in m^2 takes into account surface from windings
def Surface(Core,fillfactor):
 o_d = Core[5]#outer diameter
 i_d = Core[6]#inner diameter
 h_t = Core[7]#height
  #Based on change in surface area calculate approx size of winding
 #The last 0.5 was added due to fitting quite well with the surface better approx at larger cores
 if fillfactor>1:
  r_new = 0
 else:
  r_new = fillfactor**0.5*(i_d/2)
 o_d = o_d+1*r_new
 i_d = i_d-2*r_new
 h_t = h_t + 2*r_new
 Surface_area = 2*math.pi*((o_d/2)**2-(i_d/2)**2)+2*3.14*(o_d/2+i_d/2)*h_t
 Surface_area = Surface_area*10**-6
 return Surface_area 

#Takes a surface in m^2 and Powerloss in W returns temp increas in C 
def new_temperature_increase(Surface,Powerloss):   
 #magnetics 2-7 ((loss in mw)/surface(cm^2))^0.833
 temp_increase = ((Powerloss*1000)/(Surface*10000))**0.833
 #print "Surface",Surface,"Powerloss",Powerloss,"temp_increase",temp_increase   
 return temp_increase

#bias in A*T/cm  L-e is path length if any input parameters = 0 returns 0
#returns h in cm
def DC_Bias(N,Idc,le):
 #print "le",le,N,Idc   
 #magnetics 2-1 and example at 2-11
 if N != 0 and le != 0 and Idc != 0:
  Hdc = N*Idc/le #le here is in cm which is correct.
  #print "Hdc =",Hdc, "N = ",N ,"le =", le, "Idc =", Idc
  return Hdc
 else:
  print "problem Dc_bias", N,Idc  
  return 0
  
#takes in turns, ac current peak, core length in cm, my ie m_r*my_0
#returns Bpeak
def Bmax(N,Iac_peak,le,My):
 #sinusoidal function, so delta_I = 2x Iac_peak   
 delta_I = 2*Iac_peak    
# deltaH = N*deltaI/le
 delta_h = N/le*(delta_I) #
 #print "My =",My,"delta_h",delta_h,"le =", le,"delta_I", delta_I
 # *100 because tesla need to be in meteres while delta h is in cm
 Bpeak = 0.5*My*delta_h*100
 return Bpeak
 
def ImportLossDatabrochause():
    
 main_list = read_csv("CoreData.csv")      
 Core = findCore(main_list,"0077715A7 ")
 Loss_data = read_csv("CoreLoss_data.csv")   
 Freq   = 4000
 B_flux = 0.00

 #Loss_table = read_csv("6mars20graderlongseries.csv")    
 #Loss_table2 = read_csv("7mars200graderlongseries.csv")
 
 #Loss_table = read_csv("20C2-230MT2500F.csv")    
 #Loss_table2 = read_csv("200C2-230MT2500F.csv") 
 Loss_table = read_csv("Torbjorn_HighFlux160_C058583A2_5khz_20C.csv")    
 Loss_table2 = read_csv("Torbjorn_HighFlux160_C058583A2_5khz_200C.csv") 
# Loss_table = read_csv("N27_Torbjorn_110C_5-220mT-4Khz.csv") 
#Loss_table2 = read_csv("N27_Torbjorn_110C_5-220mT-4Khz.csv")  

 Density = 7.7
 Loss1 = [] 
 Loss2 = []
 Loss3 = []
 Loss4 = []
 Loss5 = []
 Value = 0
 Number = 0
 Permability = 0
 Counter = 0
 T       = 0
 n = 0
 Line_collum_B  = 3   # 3 = Hcontroll 4 = Bcontroll
 Line_collum_Nr = 23  #6 Total losses or 23->hysteresis
 Number_results = 3
 Max_rows       = 407 
 
 for line in Loss_table:
  n = n+1
  if n == Max_rows:
   break
  Counter = Counter +1
  if(Counter == Number_results):
   Value = Value +1
   Number = Number + line[Line_collum_Nr]
   Permability =  Permability +line[12]
   if(Value == 0):
    Value = 1
   print line[Line_collum_Nr] 
   Loss2.append(line[Line_collum_Nr] * Density)         
#  Loss2.append(Number / Value*Density)
#  Loss4.append(Number / Value*Density)   
   Permability =  Permability / Value / 10
   
   Loss3.append(Permability)
   Loss1.append((line[4])/1000)
   Loss5.append(1000*CoreLosses(Core,T,line[4]/1000,Freq,1,Loss_data,Loss_data,Loss_data)*1/((Core[10])/1000))
   #print Number / Value*Density
   Value = 0   
   Number = 0
   Counter = 0 
   Permability = 0
  else:
   Loss4.append(line[Line_collum_Nr] * Density)
       
   Value = Value +1
   Number = Number + line[Line_collum_Nr]
   Permability =  Permability +line[12]

 Loss4.pop()

 

 print len(Loss1),len(Loss2),len(Loss3),len(Loss4),len(Loss5)
 
 plot(Loss1,Loss5,label="Analytical")
 hold(True)     
 plot(Loss1,Loss2,label="Hcontroll")
 hold(True)
 #plot(Loss1,Loss4,label="Bcontroll")
 #hold(True)
 plot(Loss1,Loss3,label="1/10 Permability")  
 xlabel('Flux Density mT')
 ylabel('Core Loss mW/cm^3')
 legend(loc='upper left')
 hold(False) 
 show() 

 Loss6 = [] 
 Loss6.append(Loss1)
 Loss6.append(Loss5)
 Loss6.append(Loss2)
 Loss7 = []
 Loss7.append(Loss6) 
 write_log("Loss5.csv",Loss7) 
 return



#This takes a specific core and try to make it work with a itterative algro until the temperature is steady
def itterating_loop(Core,Ta,Idc,Iac_peak,Ac_Ripple,L,Fundamental_Freq,inverter_freq,Tmax,CoreData,max_temperature_deviation,n_min_itterations,Current_density,winding_factor2,Wire_standard,Loss_data,Temperature_table,Dc_bias_table,Frequency_table,Ferrite_my_f,Ferrite_my_t,Max_W_L,Ferrite_loss,Ferrite_loss_t,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,FastThermal,Heatsink,Thermalwinding,Litz,Iac_peak_fund):
 #Limits height diameter
 if(Core[7]>Height_Limited):
  return [0,0] 
 if(Core[5]>Diameter_Limited):
  return [0,0]  
 Ac_Ripple_current = Iac_peak*Ac_Ripple #this is mainly used to calc core losses
 Ac_Ripple_current_Avg = CurrentAvg*Ac_Ripple # this is used to to calc copper losses
 Bias_peak         = Iac_peak_fund#Iac_peak#*(1-Ac_Ripple)# Nb Idc is actual dc-current while this is the dc-bias at peak fundemental used for permability adjustment.
 my_0              = 4*math.pi*10**-7   
 my_core           = Core[1]#inital permability for the material
 turns             = 1 #Need a starting point for the number of windings
 le_initial        = Core[8]*10**-1  #path length in cm    core[8] is in mm 
 Al                = Core[4]  
 le = le_initial
 Ae                = Core[9]*10**-2  #mm^2->cm^2
 Ve                = Core[10]*10**-3 #mm^3->cm^3
  
 Material          = Core[2] #Mpp highflux etc
 Temperature       = Ta
 delta_temperature = 5  #initial for the itterating process
 Alnew             = Al
 Copperloss        = 0
 CoreLoss          = 0
 Core_temperature  = 0
 my_correction     = 1
 fillfactor        = 0
 le_gap            = 0  # Gap length
 my_eff            = 1  # Effective permability 
 Core_ID           = Core[6]
 Bool_Powder       = is_Powder(Material)
 Al_from_leak      = 0
####################################################### 
#Before itterating
 my_initial = my_0*my_core
 #checking if the core is inside the pysical limits
 min_correction = 0.01  #Bmax^2 <LI^2*my/(Vc) the minimum core size is at correction 0.5 
 if (LIIlimit(Core,L,Ac_Ripple_current,min_correction)==1):
  return [0,0]
 Wire_O_D = Wire_selector(CurrentAvg,Current_density,Wire_standard,Litz)
 fillfactor    = fill_factor(Core_ID,Wire_O_D,turns) #fill_factor(Core_ID,Wire_O_D,turns):
 if fillfactor > winding_factor2: # Higher temp and so on wont lower the fillfactor
  print "returned",turns,Wire_O_D
  return [0,0]
 #print "DeltaB =" ,deltaB
####################################################### 
#After itterating 
 H = 0
 Bpeak = 0
 
 plot_x =[]
 plot_y =[]
 plot_z =[] 
  
 n = 0
 while abs(delta_temperature) > max_temperature_deviation or n<n_min_itterations:
  le = le_initial
  n = n+1
  my             = my_initial*my_correction
  if(Bool_Powder):
   #permability have allot to say so this stabilize some early in the process   
   if n>2:   
    my_correction  = My_mod_powder(Material,my_core,H,Temperature,inverter_freq,Temperature_table,Dc_bias_table,Frequency_table)  

   Bpeak          = Bmax(turns,Ac_Ripple_current,le,my)#Ferrite just use the gap length to choose a B
   Bpeak_fund     = Bmax(turns,Iac_peak,le,my)
   turns          = Turns(Alnew,L) 
  else:
   my_correction1  = My_mod_Ferrite(Material,my_core,Temperature,inverter_freq,Ferrite_my_f,Ferrite_my_t) 
   Idim           = Iac_peak+Idc
   Bpeak          = Bmaximum(Material) # The rel perm can be adjusted to obtain Bsat as Bpeak

   my_eff         = Ve*10**-6*Bpeak**2/(my_0*Idim**2*L)
   le_gap         = le*(1/my_eff+1/(my_core*my_correction1)) #le gap in cm or value of le the my_correction1 is due to change in perm from the base
   le             = le_initial + le_gap
   turns          = round(math.sqrt(L*le*10**-2/(my_eff*my_0*Ae*10**-4))) # This need to be a integer rounds to closest integer B flux and gap is now changed.
   if(turns == 0):
    turns = 1
   my_eff         = ((Bpeak*le*10**-2)/(turns*Idim*my_0)) #
   my_correction  = my_eff / (my_core)
   Bpeak          = turns*Idim*my_eff*my_0/(le*10**-2) 
   print "me",my_eff,"my_correction",my_correction,"Bpeak",Bpeak,"Turns", turns,"Gap",le_gap        
   Bpeak_fund     = Bpeak     
   Bpeak          = Bpeak * Ac_Ripple  #the bpeak used to det losses at switching frequency
   Al_from_leak   = Leakage_Ind(turns,Ae,le,Material,le_gap)/(turns**2*10**-9)  #leakage inductance not considred.
  H              = DC_Bias(turns,Bias_peak+Idc,le)
  if(Bool_Powder):
   #Adjusts for leakage inductance by adding it to the al  
   Al_from_leak   = Leakage_Ind(turns,Ae,le,Material,le_gap)/(turns**2*10**-9)
   Alnew          = Al*my_correction + Al_from_leak
  else:
   Alnew          = Al+Al_from_leak  #*10**9  due to making it into nano L which is used in other equations

  cu_resistivity = Cu_resistivity(Temperature)  
      
  Wire_O_D      = Wire_selector(CurrentAvg,Current_density,Wire_standard,Litz) #
  Layer         = Layers(Core,Wire_O_D,Max_W_L,turns) #Nb returns 0 if the turns cant fit  
  N_Layers      = len(Layer)
  fillfactor    = fill_factor(Core_ID,Wire_O_D,turns) #fill_factor(Core_ID,Wire_O_D,turns):
##Losses
  [Copperloss,Fr]           = CopperLosses(Core,Wire_O_D,cu_resistivity,Idc,Iac_peak,CurrentAvg,turns,Ac_Ripple_current_Avg,Fundamental_Freq,inverter_freq,N_Layers,Litz)
  CoreLoss_fundamental = CoreLosses(Core,Temperature,Bpeak_fund,Fundamental_Freq,Loss_data,Ferrite_loss,Ferrite_loss_t)
  CoreLoss_inverter    = CoreLosses(Core,Temperature,Bpeak,inverter_freq,Loss_data,Ferrite_loss,Ferrite_loss_t)
  #print "CoreLoss_inverter",CoreLoss_inverter,"CoreLoss_fundamental",CoreLoss_fundamental
  CoreLoss             = CoreLoss_fundamental + CoreLoss_inverter
  Powerloss            = CoreLoss + Copperloss
##Temperature
  surface = Surface(Core,fillfactor) 
  if fillfactor < 1:
   #print "powerloss itt loop",Powerloss
   Core_temperature  = Thermal_main(Core,Ta,surface,Powerloss,Forced_Conv,FastThermal,Heatsink,Thermalwinding,N_Layers,fillfactor)#new_temperature_increase(surface,Powerloss)  
  else:
   #print "Fillfactor"
   return [0,0]
  delta_temperature = (Temperature - Ta - Core_temperature)
  Temperature = Ta + Core_temperature
  plot_x.append(n)
  plot_y.append(Temperature)
  plot_z.append(Ta)
  #print "Core_temperature", Core_temperature
  #
  #print Temperature,turns
  
  #insanity check inside loop
  print "Temperature",Temperature, "my_correction",my_correction,"Turns",turns, "B ripple",Bpeak
  if(n>500):
   print "n>500"   
   return [0.4,delta_temperature]
  if(Temperature>50*Tmax) or (my_correction < -10) or (my_correction> 10): 
   print "temp my problem"
   return [0,0]
  if(my_correction == 0): #this will not become stable anyway      
    print "my=0"    
    Return_value  = [0,0]   
    return Return_value  
 #Sending output
 
 #outside loop
 if(sum(Layer)==0):
  print "Layer problem"
  Return_value  = [0,0]  
 if(my_correction>4)or(my_correction<-4):
   print "My problem"
   Return_value  = [0,0]   
   return Return_value  
 if(Copperloss == 0) or (Tmax<Temperature) or Bmaximum(Material)<Bpeak or fillfactor>winding_factor2:
  if Copperloss == 0:
   print "Copper loss 0?"
   Return_value  = [0,0]   
   return Return_value   
  else:
   Return_value = [0.1,Core[0],Temperature,Tmax,Bpeak,Bmaximum(Material),fillfactor,winding_factor2,my_correction,turns,Wire_O_D,Layer,Core_ID] 
   
   print "wierd error"
   return Return_value 
 else: 
  plot = [plot_x,plot_y,plot_z]   
  AddData(CoreData,Core,H,Bpeak,Alnew,my,turns,Wire_O_D,Copperloss,CoreLoss,Core_temperature,Temperature,plot,Current_density,my_correction,fillfactor,inverter_freq,surface,Layer,Al_from_leak,Idc,le_gap,Fr,FastThermal)   
  print "n =",n,"Bpeak =",Bpeak, "delta_temperature",delta_temperature   
  print "turns =", turns, "Alnew =", Alnew, "Copperloss", Copperloss, "CoreLoss",CoreLoss, "Core_temperature", Core_temperature      
  Return_value = [1,Core[0],Temperature,Tmax,Bpeak,Bmaximum(Material),fillfactor,winding_factor2,my_correction]  
  return Return_value


def main(main_list,L,Iac_peak,Idc,Ac_Ripple, Ta, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,FastThermal,Heatsink,Thermalwinding,LitzWire,Iac_peak_fund):
 Wire_standard = read_csv("IEC60228standardcrosssection.csv") #mm^^2 cross section starting from small sizes
 Loss_data = read_csv("CoreLoss_data.csv")
 Temperature_table = read_csv("Temperature_table.csv")
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 Ferrite_loss    = read_csv("Ferrite_Loss_steinmetz.csv")
 Ferrite_loss_t  = read_csv("Ferrite_Loss_temp.csv") 
 Ferrite_my_t  = read_csv("Ferrite_Permability_Temp.csv")
 Ferrite_my_f  = read_csv("Ferrite_Permability_Freq.csv")
  
 Notes = []
 CoreData = []
 print "Starting process expect to wait maximum 850 secs, 1 sec/core"
 n = 0
 n1 = -1 
 for line in main_list:
  n1 = n1+1   
  
  if line[0] != "Part Number":     
   line[7] = line[7]*n_cores  # Scaling up the datawith how many cores stacked H
   line[9] = line[9]*n_cores  # Scaling up the datawith how many cores stacked Ae
   line[10] = line[10]*n_cores# Scaling up the datawith how many cores stacked Ve
   line[4]  = line[4]*n_cores
   bool_found = itterating_loop(line,Ta,Idc,Iac_peak,Ac_Ripple,L,Fundamental_Freq,inverter_freq,Tmax,CoreData,max_temperature_deviation,n_min_itterations,Current_density,winding_factor2,Wire_standard,Loss_data,Temperature_table,Dc_bias_table,Frequency_table,Ferrite_loss,Ferrite_my_t ,Max_W_L,Ferrite_loss,Ferrite_loss_t,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,FastThermal,Heatsink,Thermalwinding,LitzWire,Iac_peak_fund)
   if bool_found[0] == 0:
    print "Trying Core Nr:",n1,"Dimensions too small","Elapsed time", clock()
   elif   bool_found[0] == 0.1:
    print "Try:",bool_found[1],"Temp:",bool_found[2],"/",bool_found[3],"Bpeak:",bool_found[4],"/",bool_found[5],"Fill:",bool_found[6],"/",bool_found[7],"Perm adj",bool_found[8],"Turns",bool_found[9],"Wire_OD",bool_found[10],"Core_ID",bool_found[12],"Layers",bool_found[11],"Elapsed time", clock()
   elif bool_found[0] == 1:
    Notes.append(CoreData)   
    print n1, "###################"   
    n = n+1
   else:
    Donothing = 0 
    print "Trying Core Nr:",n1,"Correction factor",bool_found[1],"Elapsed time", clock() 
   if n == n_Results: #how many results do you want 
    break
   if n1== 876:
    print "No cores found"
   
 return CoreData


def Test(Core_n):
 Loss_data = read_csv("CoreLoss_data.csv")
 Temperature_table = read_csv("Temperature_table.csv")
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 
 Permability       = Core_n[1]   #  Nb this only matches things 
 Material          = Core_n[2] 
 print Permability, Material
 
 Dc_bias_current   = 0
 Temperature       = 25
 Bpeak             = 0.0135
 inverter_freq     = 100000
 X =[]
 Y =[]
 
 for num in range(1,11):
  inverter_freq  =  inverter_freq + 0
  X.append( inverter_freq)
  Y.append(My_modifier(Material,Permability,Dc_bias_current,Temperature,inverter_freq,Temperature_table,Dc_bias_table,Frequency_table))  
 
 print CoreLosses(Core_n,Bpeak,inverter_freq,1,Loss_data)
 plot(X,Y)
 show()
 return

def Powerlosstest(main_list2):
 Loss_data = read_csv("CoreLoss_data.csv") 
 Core1 = findCore(main_list2,"0077089A7 ")
 Core2 = findCore(main_list2,"C055089A2 ")
 Core3 = findCore(main_list2,"C058089A2 ")
  
 X =[]
 Y =[]
 Z =[]
 Z2 =[]
 Z3 =[]
 T  = 0
   
 Freq = 5000
 B_flux = 0
 for num in range(1,1550):
  B_flux = B_flux +0.001
  P_MPP = 1000*CoreLosses(Core2,T,B_flux,Freq,1,Loss_data,Loss_data,Loss_data)*1/((Core2[10])/1000)
  P_HF  = 1000*CoreLosses(Core3,T,B_flux,Freq,1,Loss_data,Loss_data,Loss_data)*1/((Core3[10])/1000)
  P_Ku  = 1000*CoreLosses(Core1,T,B_flux,Freq,1,Loss_data,Loss_data,Loss_data)*1/((Core1[10])/1000)
  P_XF  = 0 #1000*CoreLosses(main_list2[519],T,B_flux,Freq,1,Loss_data,Loss_data,Loss_data)*1/((main_list2[519][10])/1000)

    
  X.append(B_flux)
  if(B_flux<0.75):# and (P_MPP <100):#Mpp 0.75
  #CoreLosses(Core,T,B_flux,Freq,Loss_data,Ferrite_loss,Ferrite_loss_t):
   Y.append(P_MPP) 
  else:
   Y.append(0)
  if(B_flux<1.5):# and (P_HF <100):  #high flux 1.5
   Z.append(P_HF)
  else:
   Z.append(0)
  if(B_flux<1.05):# and (P_Ku <100):#kool 1.05 
   Z2.append(P_Ku)
  else:
   Z2.append(0)
  if(B_flux<1.6) and (P_XF <100): #Xflux 1.6 
   Z3.append(P_XF)
  else:
   Z3.append(0) 
 plot(X,Y,label=r'$MPP-125$')
 hold(True)
 plot(X,Z,label=r'$High Flux-125$')
 hold(True)
 plot(X,Z2,label=r'$KoolMu-125$')
 #hold(True)
 #plot(X,Z3,label=r'$Xflux-60$') 


 
 xlabel('Flux Density T')
 ylabel('Core Loss mW/cm^3')

 legend(loc='upper left')
 hold(False) 
 show() 
 
 return
def findCore(main_list,Name) :
 Core = []   
 for line in main_list:
  if line[0] == Name:
   Core = line
   break    
 return Core   

def Brochause_Read_permability(main_list):
 #Loss_table = read_csv("Brochause_Filter_HighFlux160_C058583A2.csv") 
 Loss_table = read_csv("Brochause_Filter_KoolU125_0077715A7.csv") 
 #C058583A2 160u HighFlux 4150
 #0077715A7 125u koolu 15900
 #C058548A2 125u HighFlux 5340
 Core = findCore(main_list,"0077715A7 ")
 Core[7] = Core[7]*1 #for stacking    
 Temperature_table = read_csv("Temperature_table.csv")
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 
 turns = 136 
 perm  = 125   
 
 iVector = []
 uVector = []
 uAnaVector =[]
 for line in Loss_table:
  iVector.append(line[15])
  uVector.append(line[12]/perm)
  dc = DC_Bias(turns,line[15],Core[8]*10**-1)
  uAnaVector.append(My_mod_powder(Core[2],perm,dc,25,10,Temperature_table,Dc_bias_table,Frequency_table))
  
  #print line[12]/perm,My_mod_powder(Core[2],perm,dc,25,10,Temperature_table,Dc_bias_table,Frequency_table)

 plot(iVector,uVector,label=r'$U real value$')
 #hold(True)
 plot(iVector,uAnaVector,label=r'$U analytical$')
 #hold(True) 
 xlabel('Peak Current I')
 ylabel('U/U0')

 legend(loc='upper right')
 hold(False) 
 show() 
 
 #print len(iVector),len(uVector),len(uAnaVector)
  
 return   

def Brochause_loss(main_list): 
 #C058583A2 160u HighFlux 4150
 #0077715A7 125u koolu 15900
 #C058548A2 125u HighFlux 5340
 Core = findCore(main_list,"C058548A2 ")
 Core[7] = Core[7]*1 #for stacking
 turns    = 103
 Wire_O_D = 1.55/1000
 print Wire_O_D
 #def Layers(Core,Wire_O_D,Maxlayers,turns):
 layer = Layers(Core,Wire_O_D,100,turns)
 N_Layers = len(layer)
 #def MLT(core,Wire_O_D,N_Layers):
 mlt = MLT(Core,Wire_O_D,N_Layers)
 print "Mlt and layer: ", mlt,layer
     
 Loss_data = read_csv("CoreLoss_data.csv")   
 Freq   = 5000
 Density= 6.8
 B_flux = 0.106
 T      = 0    #powder core no temperature dependency
 Loss = 1000/Density*CoreLosses(Core,T,B_flux,Freq,Loss_data,Loss_data,Loss_data)*1/((Core[10])/1000)
 print "Loss =",Loss,CoreLosses(Core,T,B_flux,Freq,Loss_data,Loss_data,Loss_data)*1/((Core[10])/1000) 
 
 return  
 
def maxTurns(Core,N,Idc,T,f,le,Al,Material,Permability,Temperature_table,Dc_bias_table,Frequency_table): 
 H1 = DC_Bias(N,Idc,le) 
 MyAdjust  = My_mod_powder(Material,Permability,H1,T,f,Temperature_table,Dc_bias_table,Frequency_table) 
 L1 = N**2*(Al*MyAdjust)*10**-9   

 H2 = DC_Bias(N+1,Idc,le) 
 MyAdjust  = My_mod_powder(Material,Permability,H2,T,f,Temperature_table,Dc_bias_table,Frequency_table) 
 L2 = (N+1)**2*(Al*MyAdjust)*10**-9 
 if L1 < L2:
  return 1   
 else:
  return 0
 
def MaximumTurns(Core):
 Temperature_table = read_csv("Temperature_table.csv")
 Dc_bias_table = read_csv("Dc_bias_table.csv")
 Frequency_table = read_csv("Frequency_table.csv")
 Idc       = 1
 T         = 25
 f         = 10000   
 le        = Core[8]*10**-1  #path length in cm    core[8] is in mm 
 Al        = Core[4]  
 Material  = Core[2]
 Permability=Core[1] 

 N = 1
 while(maxTurns(Core,N,Idc,T,f,le,Al,Material,Permability,Temperature_table,Dc_bias_table,Frequency_table)):
  N = N+1
 
 print N
 return 0
 
 
 
def MainSheel_initalize(Sort_by,csv_filename,L,Iac_peak, Idc,Ac_Ripple, Ta, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,LitzWire,Heatsink,FastThermal,CoreNumber,Thermalwinding,Iac_peak_fund):
 if(CoreNumber==0): 
  main_list2 = read_csv(csv_filename)
  main_list = sorted(main_list2, key=lambda Core: Core[Sort_by])
 else:
  main_list2 = read_csv(csv_filename)
  main_list = []
  main_list.append(findCore(main_list2,CoreNumber))
  
 
 
 Notes = main(main_list,L,Iac_peak, Idc,Ac_Ripple, Ta, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,FastThermal,Heatsink,Thermalwinding,LitzWire,Iac_peak_fund)
 #write_log("Log.csv",Notes)
 #Complex Sort
 Sorted_results = sorted(Notes, key=lambda Core: Core[22])#Sort on loss
 Sorted_results2 = sorted(Sorted_results, key=lambda Core: Core[0][1][10])#Sort on volume


 if(csv_filename == "CoreData.csv"):
  write_log("Results_Powder.csv", Sorted_results2)
 else:
  write_log("Results_Ferrite.csv", Sorted_results2)

 n = 0
 for line in Notes:
  plot(Notes[n][12][1][0],Notes[n][12][1][1],label=Notes[n][0][1][0])
  hold(True)
 # pylab.plot(Notes[n][10][1][0],Notes[n][10][1][2])
  n = n+1
 xlabel('Iteration')
 ylabel('Core Loss mW/cm^3')

 legend(loc='upper right')
 hold(False) 
 show() 
 return

 

def manual_initialize_testing():
 #Get the values from a csv
 LitzWire         = [] 
 Input_Parameters = read_csv("InputParameters.csv")
 Idc             = Input_Parameters[0][1]   #Dc current dc-bias
 winding_factor2 = Input_Parameters[1][1]   #max Fillfactor for core window 2-2 and 2-6 typical max value
 Ta    = Input_Parameters[2][1]  #Ambient Temperature
 Tmax            = Input_Parameters[3][1]   #Maximum operating temp for the core
 L               = Input_Parameters[4][1] #Inductance neccesary
 Iac_peak        = Input_Parameters[5][1]     #Ac current at 60hz maximum secure value is 26.6A due the wire table frequency is assumed to be low so Rac = Rdc
 Fundamental_Freq= Input_Parameters[6][1]   #just making it into a floating point due to permability messes things up when dividing by 10^6
 csv_filename    = Input_Parameters[7][1] #'CoreData.csv' #Input database
 Ac_Ripple       = Input_Parameters[8][1]   # 0.1 = 10% Iac_peak 
 inverter_freq   = Input_Parameters[9][1] #Frequency of the inverter
 n_Results       = int(Input_Parameters[10][1])  #how many cores do you want back
 max_temperature_deviation = Input_Parameters[11][1]   #The loop runs until n_min_itterations and max_temperature is fullfiled or to many itterations and it abort ie not able to get the loop stable
 n_min_itterations = int(Input_Parameters[12][1]) ##The loop runs until n_min_itterations is fullfiled nb to avoid the loop getting stuck a nmax is in place in the code of 500
 Sort_by         = int(Input_Parameters[13][1]) #10 = volume 5=outer radius In the imported database there is 10 collums and you can sort database depending on this the first n results from this sorted list is given out
 n_cores         = int(Input_Parameters[14][1])  #Magnetics says its easy to add cores ontop of eachother this do so you can try stacking cores, nb volume with x cores have to be manually calculated from the cores
 Current_density = Input_Parameters[15][1]
 Max_W_L         = Input_Parameters[16][1]  #Max winding layers
 CurrentAvg      = 3/math.sqrt(2)
 Height_Limited  = 5000
 Diameter_Limited= 5000
 AirGapLimit     = 5000
 Forced_Conv     = 0
 FastThermal     = 2
 Heatsink        = 8888888
 Thermalwinding  = 0
 LitzWire.append(2) 
 LitzWire.append(1.05)
 LitzWire.append(0.1)
 LitzWire.append(90)
 
 main_list2 = read_csv(csv_filename)
 main_list = sorted(main_list2, key=lambda Core: Core[Sort_by])
 Ferrite_list2 = read_csv('Core_Ferrite.csv')
 Ferrite_list = sorted(Ferrite_list2, key=lambda Core: Core[Sort_by])

 #Powerlosstest(main_list2)
 #print Layers(main_list2[2],0.0000452,3,270)
 #Powerlosstest(main_list2)   
 #Test(main_list[17])   #Testing permability for diff conds.
 main_list3 =[]
 #C058583A2 160u HighFlux 4150
 #0077715A7 125u koolu 15900
 #C058548A2 125u HighFlux 5340
 
 testCore = findCore(main_list,"0077715A7 ")
 main_list3.append(testCore)
 #print main_list3[0]
 #Test(main_list2[695])
 
 
 #Notes = main(Ferrite_list,L,Iac_peak, Idc,Ac_Ripple, Ta, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit)
 Notes = main(main_list3,L,Iac_peak, Idc,Ac_Ripple, Ta, Fundamental_Freq,inverter_freq,Tmax,n_Results,max_temperature_deviation,n_min_itterations,n_cores,Current_density,winding_factor2,Max_W_L,Height_Limited,Diameter_Limited,AirGapLimit,CurrentAvg,Forced_Conv,FastThermal,Heatsink,Thermalwinding,LitzWire)
 
 Sorted_results = sorted(Notes, key=lambda Core: Core[22])#Sort on volume
 Sorted_results2 = sorted(Sorted_results, key=lambda Core: Core[0][1][10])#sort on loss
 write_log("Log.csv", Sorted_results2)
 n = 0
 for line in Notes:
  plot(Notes[n][12][1][0],Notes[n][12][1][1],label=Notes[n][0][1][0])
  hold(True)
 # pylab.plot(Notes[n][10][1][0],Notes[n][10][1][2])
  n = n+1
 xlabel('Flux Density T')
 ylabel('Core Loss mW/cm^3')

 legend(loc='upper right')
 hold(False) 
 show() 
   
 return 0

#ImportLossDatabrochause()

#Ferrite_list = read_csv('Core_Ferrite.csv')
main_list = read_csv("CoreData.csv")
#Brochause_Read_permability(main_list
#Brochause_loss(main_list)
#manual_initialize_testing()
Core = findCore(main_list,"C058548A2 ")
#MaximumTurns(Core)
#Brochause_loss(main_list)
#Calculate_T(Core,Ta,T_est,Powerloss,Velocity,alpha_w,R_sink,Fillf,N_Layers,emissivity,Mounting)
#print Thermal_main(Core,293.15,0.004917,3,0,0,0,0,10,0.8)